% This package contains the sample code for implementation of the work on depth recovery [1][2]. Note that the sample code is run 
% with the block size of 60x60.  Too large block sizes may cause the "out of memory" problem. So, the partition-and-processing 
% strategy is needed to process large depth maps. Please cite our work [1][2] if you use this code in your research, and 
% contact {yexch,yjy,lik}@tju.edu.cn for problems in using this code. See  data 
% and results at the project website at http://cs.tju.edu.cn/faculty/likun/projects/depth_recovery/index.htm
% 
% 
% [1]. Jingyu Yang, Xinchen Ye, Kun Li, Chunping Hou, Yao Wang, "Color-guided depth recovery from RGB-D data using an adaptive 
% autoregressive model", IEEE Transactions on Image Processing, vol. 23, no. 8, pp. 3443-3458, 2014.
% [2]. Jingyu Yang, Xinchen Ye, Kun Li, and Chunping Hou, "Depth recovery using an adaptive color-guided auto-regressive model", 
% European Conference on Computer Vision (ECCV), October 7-13, 2012, Firenze, Italy.  

%%%%
%read from .mat
j=2;
S=load(strcat('test',int2str(j),'.mat'));
disp(j)

%%%%%%%%%%%%%%%%
%input arguement
guidedmap=double(S.temp_g); %guided image
colormap1 = double(image_rgb2yuv(S.temp_c));%color image
G=double(S.temp_s);%sampled image
origin=double(S.temp_d); %ground
block_size =60;
[height,width] = size(G);
mu = 200;
maxitr = 30;
beta = 0.01;
gamma = 1.2;
% finite diff
f = [];
X = guidedmap(:);
Lam = zeros(height*width,1);
%%%%%%%%%%%%%%%%%
%PtP=P'*P, B = Ptd construct
G_temp=G;
G_column=G_temp(:);
G_column_index=find(G_column~=0);
G_column_valid=G_column(G_column_index);
P=zeros(length(G_column_valid),length(G_column));
tic
for k=1:length(G_column_valid);
  P(k,G_column_index(k))=1;
end
PtP = P'*P;
B = P'*G_column_valid;
%%%%%%%%%%%%%%%%%%
%AR construct
Q = AR_construct(colormap1,guidedmap, block_size,4,3);
QtQ = Q'*Q;
%%%%%%%%%%%%%%%%%%
% Recovery
X=(PtP+(1/mu)*QtQ)\B; 


%%%reshape
X=reshape(X,block_size,block_size);

imshow(uint8([origin X]))
